package com.yifu.cloud.plus.v1.yifu.salary.service.impl;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.yifu.cloud.plus.v1.yifu.archives.entity.TEmployeeInfo;
import com.yifu.cloud.plus.v1.yifu.archives.vo.TSettleDomainSelectVo;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.CommonConstants;
import com.yifu.cloud.plus.v1.yifu.common.core.util.Common;
import com.yifu.cloud.plus.v1.yifu.common.core.util.DateUtil;
import com.yifu.cloud.plus.v1.yifu.common.core.util.ExcelUtil;
import com.yifu.cloud.plus.v1.yifu.common.core.util.R;
import com.yifu.cloud.plus.v1.yifu.common.core.vo.YifuUser;
import com.yifu.cloud.plus.v1.yifu.common.security.util.SecurityUtils;
import com.yifu.cloud.plus.v1.yifu.salary.entity.SysMessageSalary;
import com.yifu.cloud.plus.v1.yifu.salary.entity.SysMessageSalaryTemp;
import com.yifu.cloud.plus.v1.yifu.salary.entity.TSalaryAccount;
import com.yifu.cloud.plus.v1.yifu.salary.mapper.SysMessageSalaryMapper;
import com.yifu.cloud.plus.v1.yifu.salary.service.SysMessageSalaryService;
import com.yifu.cloud.plus.v1.yifu.salary.service.SysMessageSalaryTempService;
import com.yifu.cloud.plus.v1.yifu.salary.service.TSalaryAccountService;
import com.yifu.cloud.plus.v1.yifu.salary.vo.SysMessageSalaryExportVo;
import com.yifu.cloud.plus.v1.yifu.salary.vo.SysMessageSalarySearchVo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 最低工资提醒-每月更新一次
 *
 * @author hgw
 * @date 2019-11-21 17:18:10
 */
@Service("sysMessageSalaryService")
public class SysMessageSalaryServiceImpl extends ServiceImpl<SysMessageSalaryMapper, SysMessageSalary> implements SysMessageSalaryService {
  /*  @Autowired
    private PreRemoteBasicArchivesService preRemoteBasicArchivesService;
    @Autowired
    private RemoteBasicArchivesService remoteBasicArchivesService;*/
    @Autowired
    private TSalaryAccountService salaryAccountService;
    @Autowired
    private SysMessageSalaryTempService sysMessageSalaryTempService;
  /*  @Autowired
    private RemoteTSettleDomainService remoteTSettleDomainService;*/


    /**
     * 最低工资提醒-每月更新一次简单分页查询
     *
     * @param sysMessageSalary 最低工资提醒-每月更新一次
     * @return
     */
    @Override
    public IPage<SysMessageSalary> getSysMessageSalaryPage(Page<SysMessageSalary> page, SysMessageSalary sysMessageSalary) {
        YifuUser user = SecurityUtils.getUser();
       /* if (!SecurityUtils.isHaveAllOrg(ServiceNameConstants.SERVICE_NAME_WXHR, user)) {
            R<List<TSettleDomainSelectVo>> remoteGetTSettleDomainVo =
                    preRemoteBasicArchivesService.getInnerSettleDomainSelectVosByExtendUser(SecurityUtils.getUser());
            if (remoteGetTSettleDomainVo == null) {
                throw new CheckedException("调用结算服务失败");
            }
            if (CommonConstants.SUCCESS != remoteGetTSettleDomainVo.getCode()) {
                throw new CheckedException("调用结算服务返回失败");
            }
            List<TSettleDomainSelectVo> remoteSettleDomainVoData = remoteGetTSettleDomainVo.getData();
            if (remoteSettleDomainVoData == null) {
                throw new CheckedException("未获取到相关结算信息");
            }
            return baseMapper.getSysMessageSalaryPage(page, sysMessageSalary, remoteSettleDomainVoData);
		} else {
		}*/
		return baseMapper.getSysMessageSalaryPage(page, sysMessageSalary, null);
	}

    @Override
    public IPage<SysMessageSalary> getSysMessageSalaryHandlePage(Page<SysMessageSalary> page, SysMessageSalary sysMessageSalary) {
        return baseMapper.getSysMessageSalaryHandlePage(page, sysMessageSalary);
    }

    /**
     * @Author fxj
     * @Description 新增-普通工资
     * @Date 18:19 2022/8/17
    **/
    @Transactional
    @Override
    public void insertSalaryBySettleMonth(String settleMonth) {
        List<SysMessageSalary> sysMessageSalaries = baseMapper.insertSalaryBySettleMonth(settleMonth);
        R<List<TEmployeeInfo>> employeeInfoListR = null;//remoteBasicArchivesService.getEmployeeListForImportCheckByIds(Common.listObjectToStr(sysMessageSalaries, "employeeId", CommonConstants.COMMA_STRING), SecurityConstants.FROM_IN);
        HashMap<String, TEmployeeInfo> employeeInfoMap = Maps.newHashMap();
        List<TEmployeeInfo> employeeInfoList = employeeInfoListR.getData();
        for (TEmployeeInfo employeeInfo : employeeInfoList) {
            employeeInfoMap.put(employeeInfo.getId(), employeeInfo);
        }
        //获取单位名称
        Map<String, TSettleDomainSelectVo> settleDomainSelectVoMap=Maps.newHashMap();
        R<List<TSettleDomainSelectVo>> remoteTSettleDomainyIds = null;//remoteTSettleDomainService.getSettleDomainByIds(Common.listObjectToStrList(employeeInfoList, "settleDomain"), SecurityConstants.FROM_IN);
        if(remoteTSettleDomainyIds!=null&&remoteTSettleDomainyIds.getData()!=null){
            for (TSettleDomainSelectVo selectVo : remoteTSettleDomainyIds.getData()) {
                settleDomainSelectVoMap.put(selectVo.getId(),selectVo);
            }
        }
        for (SysMessageSalary sysMessageSalary : sysMessageSalaries) {
            //标准合同和临时人员才会提醒
            TEmployeeInfo employeeInfo = employeeInfoMap.get(sysMessageSalary.getEmployeeId());
            if (employeeInfo == null) {
                continue;
            }
            if(CommonConstants.ZERO_INT != employeeInfo.getFileStatus()){
                //非在职
                continue;
            }
            if (StringUtils.equals(CommonConstants.ONE_STRING, employeeInfo.getEmpNatrue())) {
                TSettleDomainSelectVo selectVo = settleDomainSelectVoMap.get(employeeInfo.getDeptId());
                sysMessageSalary.setCustomerId(selectVo!=null?selectVo.getCustomerId():null);
                sysMessageSalary.setCustomerName(selectVo!=null?selectVo.getCustomerName():null);
                this.save(sysMessageSalary);
            }

        }
    }


    /**
     * @param settleMonth 结算月
     * @Description: 生成前，先删除老数据
     * @Author: hgw
     * @Date: 2019/11/21 17:28
     * @return: void
     **/
    @Override
    @Transactional
    public void deleteAllBySettleMonth(String settleMonth) {
        baseMapper.deleteAllBySettleMonth(settleMonth);
    }


    @Override
    public void createSysMessageSalaryTemp(String month) {
        //删除之前的数据
        sysMessageSalaryTempService.remove(Wrappers.<SysMessageSalaryTemp>query().lambda().eq(SysMessageSalaryTemp::getSettleMonth, month));
        //获取当月的所有最低工资，并且是临时人员
        // 获取他上次发工资是不是在最低工资表里面 次数+1
        //继续循环上次，如果发现上次没有在最低工资表里面，则循环下一个人员
        List<SysMessageSalary> list = this.list(Wrappers.<SysMessageSalary>query().lambda().eq(SysMessageSalary::getSettleMonth, month));
        R<List<TEmployeeInfo>> employeeInfoListR = null;//remoteBasicArchivesService.getEmployeeListForImportCheckByIds(Common.listObjectToStr(list, "employeeId", CommonConstants.COMMA_STRING), SecurityConstants.FROM_IN);
        HashMap<String, TEmployeeInfo> employeeInfoMap = Maps.newHashMap();
        List<TEmployeeInfo> employeeInfoList = employeeInfoListR.getData();
        for (TEmployeeInfo employeeInfo : employeeInfoList) {
            employeeInfoMap.put(employeeInfo.getId(), employeeInfo);
        }
        //获取当月的所有最低工资，并且是临时人员
        List<SysMessageSalary> tempSysMessageSalary = Lists.newArrayList();
        for (SysMessageSalary salary : list) {
            TEmployeeInfo employeeInfo = employeeInfoMap.get(salary.getEmployeeId());
			tempSysMessageSalary.add(salary);
        }
        for (SysMessageSalary messageSalary : tempSysMessageSalary) {
            //获取他上次发工资是不是在最低工资表里面 次数+1
            List<TSalaryAccount> accountList = salaryAccountService.list(Wrappers.<TSalaryAccount>query().lambda().eq(TSalaryAccount::getEmpIdcard, messageSalary.getEmployeeIdnum())
                    .lt(TSalaryAccount::getSalaryGiveTime, messageSalary.getSalaryMonth()).groupBy(TSalaryAccount::getSalaryGiveTime).orderByDesc(TSalaryAccount::getSalaryGiveTime));
            int lowerConut = 1;
            for (TSalaryAccount salaryAccount : accountList) {
                long count = this.count(Wrappers.<SysMessageSalary>query().lambda().eq(SysMessageSalary::getEmployeeId, salaryAccount.getEmpId()).eq(SysMessageSalary::getSalaryMonth, salaryAccount.getSalaryGiveTime()));
                if (count > 0) {
                    //如果大于0 则上次也是最低工资。
                    lowerConut++;
                } else {
                    break;
                }
            }
            //判断最低次数
            if (lowerConut > 1) {
                SysMessageSalaryTemp messageSalaryTemp = new SysMessageSalaryTemp();
                messageSalaryTemp.setRelateId(messageSalary.getId());
                messageSalaryTemp.setTimes(lowerConut);
                messageSalaryTemp.setSettleMonth(month);
                sysMessageSalaryTempService.save(messageSalaryTemp);
            }

        }


    }
	/**
	 * @Author fxj
	 * @Description 最低工资提醒导出
	 * @Date 18:12 2022/8/17
	**/
	@Override
	public void listExport(HttpServletResponse response, SysMessageSalarySearchVo searchVo) {
		String fileName = "最低工资提醒导出" + DateUtil.getThisTime() + ".xlsx";
		//获取要导出的列表
		List<SysMessageSalaryExportVo> list = new ArrayList<>();
		// TODO
		List<String> settleDomainIds =null;
		List<String> ids = null;
		String sql = null;
		int count = noPageCountDiy(searchVo,settleDomainIds,ids,sql);
		ServletOutputStream out = null;
		try {
			out = response.getOutputStream();
			response.setContentType(CommonConstants.MULTIPART_FORM_DATA);
			response.setCharacterEncoding(CommonConstants.UTF8);
			response.setHeader(CommonConstants.CONTENT_DISPOSITION, CommonConstants.ATTACHMENT_FILENAME + URLEncoder.encode(fileName  , CommonConstants.UTF8));
			// 这里 需要指定写用哪个class去写，然后写到第一个sheet，然后文件流会自动关闭
			ExcelWriter excelWriter = EasyExcel.write(out, SysMessageSalaryExportVo.class).build();
			int index = 0;
			if (count >  CommonConstants.ZERO_INT){
				for (int i = 0; i <= count; ) {
					// 获取实际记录
					searchVo.setLimitStart(i);
					searchVo.setLimitEnd(CommonConstants.EXCEL_EXPORT_LIMIT);
					list = noPageDiy(searchVo,settleDomainIds,ids,sql);
					if (Common.isNotNull(list)){
						ExcelUtil<SysMessageSalaryExportVo> util = new ExcelUtil<>(SysMessageSalaryExportVo.class);
						for (SysMessageSalaryExportVo vo:list){
							util.convertEntity(vo,null,null,null);
						}
					}
					if (Common.isNotNull(list)){
						WriteSheet writeSheet = EasyExcel.writerSheet("消息提醒"+index).build();
						excelWriter.write(list,writeSheet);
						index++;
					}
					i = i + CommonConstants.EXCEL_EXPORT_LIMIT;
					if (Common.isNotNull(list)){
						list.clear();
					}
				}
			}else {
				WriteSheet writeSheet = EasyExcel.writerSheet("消息提醒"+index).build();
				excelWriter.write(list,writeSheet);
			}
			if (Common.isNotNull(list)){
				list.clear();
			}
			out.flush();
			excelWriter.finish();
		}catch (Exception e){
			log.error("执行异常" ,e);
		}finally {
			try {
				if (null != out) {
					out.close();
				}
			} catch (IOException e) {
				log.error("执行异常", e);
			}
		}
	}

	private List<SysMessageSalaryExportVo> noPageDiy(SysMessageSalarySearchVo searchVo,
													 List<String> settleDomainIds,
													 List<String> ids,
													 String sql) {
		return baseMapper.noPageDiy(searchVo,settleDomainIds,ids,sql);
	}

	private int noPageCountDiy(SysMessageSalarySearchVo searchVo,
							   List<String> settleDomainIds,
							   List<String> ids,
							   String sql) {
		return baseMapper.noPageCountDiy(searchVo,settleDomainIds,ids,sql);
	}

	/**
	 * @Author fxj
	 * @Description 反馈信息
	 * @Date 17:23 2022/8/17
	 * @Param
	 * @return
	 **/
	@Override
	public R<String> feedback(Integer reasonType, String id, String feedBack) {
		SysMessageSalary entity = baseMapper.selectById(id);
		if (Common.isEmpty(entity)){
			return R.failed(CommonConstants.PARAM_IS_NOT_ERROR);
		}
		entity.setReasonType(reasonType);
		entity.setFeedback(feedBack);
		int res  = baseMapper.updateById(entity);
		if (res == CommonConstants.ONE_INT_NEGATE){
			return R.failed(CommonConstants.SAVE_FAILED);
		}
		return R.ok(null,CommonConstants.SAVE_SUCCESS);
	}
}
